<?php
/**
 * MySQL database adapter
 */
class db_mysql extends db_adapter {
    var $db = null;

    /**
     * MySQL constructor.
     * Can be called using a host, user, pass and database or alternatively it 
     * can be called using just an existing mysql ressource (mysql_connect
     * object)
     */
    public function db_mysql($host, $user = null, $pass = null, $dbase = null) {
        assert('function_exists("mysql_connect")');

        // host or existing conneciton given
        if (is_string($host)) {
            assert('is_string($user)');
            assert('is_string($pass)');
            assert('is_string($dbase)');
            $this->dbase = $dbase;
            $db = @mysql_connect($host, $user, $pass);
            if ($db == false) return;

            if (!mysql_select_db($this->dbase, $db)) return;
        } else {
            $db = $host;
        }

        $this->db = $db;
    }

    /**
     * Issue a database query.
     * If an error occurs, program execution will be terminated.
     */
    public function query($query) {   
        $this->log_query($query);
        $result = mysql_query($query, $this->db);
        if (!$result) die('Invalid query: ' . mysql_error().' Query: '.$query);
        return $result;
    }

    public function query_row($query) {   
        $result = $this->query($query);
        return mysql_fetch_array($result);
    }

    public function query_all($query) {
        $result = $this->query($query);
        $all = array();
        while ($row = mysql_fetch_assoc($result)) array_push($all, $row);
        return $all;
    }

    public function update($table, $record, $id) {
        $query = "UPDATE ".$table." SET ";
        $add_colon = false;
        foreach (array_keys($record) as $attr) {
            if ($add_colon) $query .= ', ';
            $query .= '`' . $attr . '`=';
            if ($record[$attr] == null) {
                $query .= "NULL ";
            } else {
                $query .= "'" . mysql_escape_string($record[$attr]) . "' ";
            }
            $add_colon = true;
        }
        $query .= "WHERE `id`=". $id . ";";

        // a least one change => query
        if (!$add_colon) return;

        // finally query
        $this->query($query);
    }

    public function insert($table, $record) {
        $query = 'INSERT INTO '.$table.' ( ';
        $values = '';
        $add_colon = false;
        foreach (array_keys($record) as $attr) {
            if ($add_colon) {
                $query .= ", ";
                $values .= ", ";
            }
            $query .= "`" . $attr . "`";
            if ($record[$attr] === null) {
                $values .= "NULL";
            } else {
                $values .= "'". mysql_escape_string($record[$attr])."'";
            }
            $add_colon = true;
        }
        $query .= ') VALUES (' . $values . ');';

        // finally query
        $this->query($query);

        // get this objects id
        return mysql_insert_id($this->db);
    }


    /**
     * Optimize this table. Call e.g. from Admin interface or once on long 
     * program run.
     */
    public static function optimize($table) {
        $query = 'OPTIMIZE TABLE `'.$table.'`';

        // TODO evaluate result
        $this->db->query($query);
    }

    // TODO: set next autoindex
    // mysql: ALTER TABLE `user` AUTO_INCREMENT=100

    public function fetch_columns($table) {
        $columns = array();
        $result = $this->query('SHOW FIELDS FROM `'.$table.'`;');
        while ($row = mysql_fetch_assoc($result)) {
            $columns[$row['Field']] = $this->convert_type($row['Type']);
        }
        return $columns;
    }

    /**
     * Convert database type to php type
     */
    private function convert_type($t) {
        if ($t == 'tinyint(1)') return 'integer';
        if ($t == 'int(11)') return 'integer';
        if ($t == 'float') return 'float';
        if ($t == 'date') return 'time';
        if ($t == 'datetime') return 'time';
        if ($t == 'timestamp') return 'time';
        if ($t == 'text') return 'string';
        if (substr($t, 0, 7) == 'varchar') return 'string';
        if (substr($t, 0, 4) == 'char') return 'string';
        die('Which type is: '. $t);
    }

    /**
     */
    public function init() {
    //    $r = strftime($this->select_single("SELECT NOW()"));
    //    echo $r."\n";
    //    $r = $this->select_single("SELECT FROM_UNIXTIME(NOW())");
    //    echo $r."\n";
    //    die();
    }

    /**
     * Select one single number from the database (e.g. a count)
     */
    public function select_single($query) {
        $result = $this->query($query);
        $row = mysql_fetch_row($result);
        assert('sizeof($row) == 1 /* ' . $query . ' */');
        return $row[0];
    }
}

